CREATE TABLE schema (version int);
INSERT INTO schema VALUES (4);
CREATE TABLE applications (url text, basename text, version int, apprecord blob, bundleid text);
CREATE TABLE typemap (uti text, application text, rank int);
CREATE TABLE types (uti text, extensions text, mimetypes text, ostypes text, pboards text, conforms text);
INSERT INTO types VALUES ('com.apple.alias-record','','inode/symlink','','','public.item,com.apple.resolvable');
INSERT INTO types VALUES ('com.apple.rtfd','rtfd','','','','com.apple.package,public.composite-content');
INSERT INTO types VALUES ('public.folder','','inode/directory','','','public.directory');
INSERT INTO types VALUES ('com.apple.metadata-importer','mdimporter','','','','com.apple.plugin');
INSERT INTO types VALUES ('com.microsoft.powerpoint.ppt','ppt','application/mspowerpoint,application/vnd.ms-powerpoint','','','public.data,public.presentation');
INSERT INTO types VALUES ('com.apple.coreaudio-format','caf','','','','public.audio');
INSERT INTO types VALUES ('public.csh-script','csh','','','','public.shell-script');
INSERT INTO types VALUES ('com.microsoft.dynamic-link-library','dll','','','','public.data,public.executable');
INSERT INTO types VALUES ('com.apple.quicktime-image','qif,qtif','image/x-quicktime','','','public.image');
INSERT INTO types VALUES ('com.apple.pict','pic,pct,pict','image/pict,image/x-pict,image/x-macpict','','','public.image');
INSERT INTO types VALUES ('public.video','','','','','public.movie');
INSERT INTO types VALUES ('public.cpio-archive','cpio','','','','public.data');
INSERT INTO types VALUES ('com.sun.java-web-start','jnlp','','','','public.xml');
INSERT INTO types VALUES ('public.xbitmap-image','xbm','image/x-bitmap','','','public.image');
INSERT INTO types VALUES ('com.apple.traditional-mac-plain-text','','','','','public.plain-text');
INSERT INTO types VALUES ('com.apple.webarchive','','','','','public.data,public.composite-content');
INSERT INTO types VALUES ('org.gnu.gnu-zip-tar-archive','tgz','','','','org.gnu.gnu-zip-archive');
INSERT INTO types VALUES ('com.apple.truetype-datafork-suitcase-font','dfont','','','','public.truetype-font');
INSERT INTO types VALUES ('com.allume.stuffit-archive','sit,sitx','application/x-stuffit,application/stuffit,application/x-sit','','','public.data,public.archive');
INSERT INTO types VALUES ('public.php-script','php,php3,php4,ph3,ph4,phtml','text/x-php-script,text/php,application/php','','','public.shell-script');
INSERT INTO types VALUES ('com.apple.colorsync-profile','icc,icm,pf','','','','public.data');
INSERT INTO types VALUES ('com.apple.alias-file','','','','','public.item,com.apple.resolvable');
INSERT INTO types VALUES ('public.composite-content','','','','','public.content');
INSERT INTO types VALUES ('public.shell-script','sh,command','','','','public.script');
INSERT INTO types VALUES ('com.adobe.postscript','ps','application/postscript','','','public.data');
INSERT INTO types VALUES ('com.apple.macbinary-archive','bin','application/x-macbinary,application/macbinary','','','public.data,public.archive');
INSERT INTO types VALUES ('public.aifc-audio','aifc','','','','public.audio');
INSERT INTO types VALUES ('public.text','txt','text/plain','','','public.content,public.data');
INSERT INTO types VALUES ('com.sun.java-class','class','application/x-java-class,application/x-java-vm,application/java-byte-code,application/x-java','','','public.data,public.executable');
INSERT INTO types VALUES ('public.png','png','image/png','','','public.image');
INSERT INTO types VALUES ('com.real.realmedia','rm','application/vnd.rn-realmedia','','','public.movie');
INSERT INTO types VALUES ('public.mp3','mp3','audio/mpeg,audio/mpeg3,audio/mpg,audio/mp3,audio/x-mpeg,audio/x-mpeg3,audio/x-mpg,audio/x-mp3','','','public.audio');
INSERT INTO types VALUES ('public.volume','','','','','public.folder');
INSERT INTO types VALUES ('com.microsoft.windows-media-wmv','wmv','video/x-ms-wmv','','','public.movie,com.microsoft.advanced-systems-format');
INSERT INTO types VALUES ('public.movie','','','','','public.audiovisual-content');
INSERT INTO types VALUES ('public.mig-source','defs,mig','','','','public.source-code');
INSERT INTO types VALUES ('com.apple.icns','icns','','','','public.image');
INSERT INTO types VALUES ('public.disk-image','','','','','public.archive');
INSERT INTO types VALUES ('com.sgi.sgi-image','sgi','image/sgi','','','public.image');
INSERT INTO types VALUES ('com.pkware.zip-archive','zip','application/zip,application/x-zip,application/x-zip-compressed','','','public.data,public.archive');
INSERT INTO types VALUES ('com.apple.applescript.text','applescript','','','','public.script');
INSERT INTO types VALUES ('com.adobe.postscript-pfa-font','pfa','','','','com.adobe.postscript-font');
INSERT INTO types VALUES ('com.microsoft.windows-media-wax','wax','video/x-ms-wax','','','public.audio,com.microsoft.advanced-stream-redirector');
INSERT INTO types VALUES ('com.apple.macpaint-image','pntg','','','','public.image');
INSERT INTO types VALUES ('com.apple.mount-point','','inode/mount-point','','','public.item,com.apple.resolvable');
INSERT INTO types VALUES ('public.file-url','','','','','public.url');
INSERT INTO types VALUES ('com.real.realaudio','ram,ra','application/vnd.rn-realaudio,audio/x-pn-realaudio','','','public.audio');
INSERT INTO types VALUES ('com.real.smil','smil','application/smil','','','public.xml');
INSERT INTO types VALUES ('com.apple.font-suitcase','suit','','','','public.font');
INSERT INTO types VALUES ('public.image','','','','','public.data,public.content');
INSERT INTO types VALUES ('com.microsoft.windows-media-wvx','wvx','','','','public.audio,com.microsoft.advanced-stream-redirector');
INSERT INTO types VALUES ('public.mpeg-4','mp4','video/mp4,video/mp4v,video/x-m4v','','','public.movie');
INSERT INTO types VALUES ('public.vcard','vcf,vcard','text/directory,text/vcard,text/x-vcard','','','public.data,public.content');
INSERT INTO types VALUES ('com.microsoft.waveform-audio','wav,wave','audio/wav,audio/wave,audio/vnd.wave,audio/x-wav','','','public.audio');
INSERT INTO types VALUES ('public.avi','avi,vfw','video/avi,video/msvideo,video/x-msvideo','','','public.movie');
INSERT INTO types VALUES ('public.fax','','','','','public.image');
INSERT INTO types VALUES ('com.adobe.illustrator.ai-image','ai','','','','public.image');
INSERT INTO types VALUES ('public.url','','','','','public.data');
INSERT INTO types VALUES ('public.opentype-font','otf','font/otf,application/x-font-otf','','','public.font');
INSERT INTO types VALUES ('com.apple.protected-mpeg-4-audio','m4p,m4b','','','','public.audio');
INSERT INTO types VALUES ('com.microsoft.windows-media-wpx','','video/x-ms-wpx','','','');
INSERT INTO types VALUES ('com.microsoft.word.doc','doc,docx','application/vnd.ms-word,application/msword','','','public.data');
INSERT INTO types VALUES ('com.microsoft.excel.xls','xls,xlsx','application/vnd.ms-excel,application/msexcel','','','public.data');
INSERT INTO types VALUES ('public.c-plus-plus-header','hpp,h++','','','','public.source-code');
INSERT INTO types VALUES ('com.adobe.encapsulated-postscript','eps','','','','com.adobe.postscript');
INSERT INTO types VALUES ('public.c-plus-plus-source','cp,cpp,c++,cc,cxx','','','','public.source-code');
INSERT INTO types VALUES ('com.microsoft.advanced-systems-format','asf','video/x-ms-asf','','','public.audiovisual-content');
INSERT INTO types VALUES ('public.source-code','','','','','public.plain-text');
INSERT INTO types VALUES ('org.gnu.gnu-zip-archive','gz,gzip','application/gzip,application/x-gzip','','','public.data,public.archive');
INSERT INTO types VALUES ('public.filename-extension','','','','','public.case-insensitive-text');
INSERT INTO types VALUES ('com.apple.bundle','bundle','','','','public.directory');
INSERT INTO types VALUES ('com.microsoft.bmp','bmp','','','','public.image');
INSERT INTO types VALUES ('public.data','','','','','public.item');
INSERT INTO types VALUES ('com.apple.ostype','','','','','public.text');
INSERT INTO types VALUES ('com.apple.txn.text-multimedia-data','','','','','public.data,public.composite-content');
INSERT INTO types VALUES ('com.apple.binhex-archive','hqx','application/mac-binhex40,application/mac-binhex,application/binhex','','','public.data,public.archive');
INSERT INTO types VALUES ('com.adobe.postscript-lwfn-font','','','','','com.adobe.postscript-font');
INSERT INTO types VALUES ('com.apple.quartz-composer-composition','qtz','application/x-quartzcomposer','','','public.data,public.executable');
INSERT INTO types VALUES ('public.audiovisual-content','','','','','public.data,public.content');
INSERT INTO types VALUES ('com.adobe.photoshop-image','psd','image/x-photoshop,image/photoshop,image/psd,application/photoshop,image/vnd.adobe.photoshop,application/x-photoshop','','','public.image');
INSERT INTO types VALUES ('public.objective-c-source','m','text/x-objcsrc','','','public.source-code');
INSERT INTO types VALUES ('com.adobe.pdf','pdf','application/pdf,application/acrobat,application/x-pdf,image/pdf','','','public.data,public.composite-content');
INSERT INTO types VALUES ('public.truetype-font','','','','','public.font');
INSERT INTO types VALUES ('public.camera-raw-image','','','','','public.image');
INSERT INTO types VALUES ('com.kodak.flashpix.image','fpx','image/fpx,application/vnd.fpx','','','public.image');
INSERT INTO types VALUES ('public.c-header','h','','','','public.source-code');
INSERT INTO types VALUES ('com.microsoft.windows-media-wmx','wmx','video/x-ms-wmx','','','public.audio,com.microsoft.advanced-stream-redirector');
INSERT INTO types VALUES ('public.symlink','','inode/symlink','','','public.item,com.apple.resolvable');
INSERT INTO types VALUES ('com.apple.applescript.script','scpt','','','','public.data');
INSERT INTO types VALUES ('com.sun.java-source','jav','','','','public.source-code');
INSERT INTO types VALUES ('public.mpeg','mpg,mpeg,m75,m15','video/mpg,video/mpeg,video/x-mpg,video/x-mpeg','','','public.movie');
INSERT INTO types VALUES ('com.microsoft.windows-media-wma','wma','video/x-ms-wma,audio/wma,audio/x-ms-wma','','','public.audio,com.microsoft.advanced-systems-format');
INSERT INTO types VALUES ('public.jpeg','jpg,jpeg','image/jpeg','','','public.image');
INSERT INTO types VALUES ('com.adobe.postscript-pfb-font','pfb','','','','com.adobe.postscript-font');
INSERT INTO types VALUES ('public.mime-type','','','','','public.case-insensitive-text');
INSERT INTO types VALUES ('com.apple.keynote.key','key','application/vnd.apple.keynote,application/x-iwork-keynote-sffkey','','','com.apple.package,public.presentation');
INSERT INTO types VALUES ('public.truetype-ttf-font','ttf','font/ttf,application/x-font-ttf','','','public.truetype-font');
INSERT INTO types VALUES ('com.microsoft.windows-media-wmp','wmp','video/x-ms-wmp,video/x-mplayer2','','','public.movie,com.microsoft.advanced-systems-format');
INSERT INTO types VALUES ('public.3gpp2','3g2,3gp2','video/3gpp2,audio/3gpp2','','','public.movie');
INSERT INTO types VALUES ('com.apple.flat-rtfd','','','','','public.data,public.composite-content');
INSERT INTO types VALUES ('com.sun.:1java-source','java','','','','');
INSERT INTO types VALUES ('com.microsoft.windows-executable','exe','application/x-msdownload','','','public.data,public.executable');
INSERT INTO types VALUES ('public.utf16-plain-text','','','','','public.plain-text');
INSERT INTO types VALUES ('com.compuserve.gif','gif','image/gif','','','public.image');
INSERT INTO types VALUES ('com.truevision.tga-image','tga','image/targa,image/tga,application/tga','','','public.image');
INSERT INTO types VALUES ('com.apple.rez-source','r','','','','public.source-code');
INSERT INTO types VALUES ('public.utf8-plain-text','','','','','public.plain-text');
INSERT INTO types VALUES ('public.truetype-collection-font','ttc','','','','public.font');
INSERT INTO types VALUES ('com.apple.package','','','','','public.directory');
INSERT INTO types VALUES ('public.ulaw-audio','au,ulw,snd','audio/basic,audio/au,audio/snd','','','public.audio');
INSERT INTO types VALUES ('public.aiff-audio','aiff,aif','audio/aiff,audio/x-aiff','','','public.audio');
INSERT INTO types VALUES ('com.j2.jfx-fax','jfx','','','','public.fax');
INSERT INTO types VALUES ('com.ilm.openexr-image','exr','','','','public.image');
INSERT INTO types VALUES ('public.mpeg-4-audio','m4a','audio/m4a,audio/mp4','','','public.audio,public.mpeg-4');
INSERT INTO types VALUES ('public.utf16-external-plain-text','','','','','public.plain-text');
INSERT INTO types VALUES ('com.adobe.postscript-font','','','','','public.font');
INSERT INTO types VALUES ('public.perl-script','pl,pm,pod','text/x-perl-script,application/x-perl','','','public.shell-script');
INSERT INTO types VALUES ('public.html','html,htm','text/html','','','public.text');
INSERT INTO types VALUES ('com.apple.plugin','plugin','','','','com.apple.package,com.apple.bundle');
INSERT INTO types VALUES ('public.3gpp','3gp,3gpp','video/3gpp,audio/3gpp','','','public.movie');
INSERT INTO types VALUES ('public.objective-c-plus-plus-source','mm','','','','public.source-code');
INSERT INTO types VALUES ('com.apple.application-bundle','app','','','','com.apple.package,com.apple.bundle,com.apple.application');
INSERT INTO types VALUES ('com.apple.quicktime-movie','mov,qt','video/quicktime','','','public.movie');
INSERT INTO types VALUES ('org.gnu.gnu-tar-archive','gtar','application/x-gtar','','','public.data,public.archive');
INSERT INTO types VALUES ('com.digidesign.sd2-audio','sd2','','','','public.audio');
INSERT INTO types VALUES ('public.tar-archive','tar','application/x-tar,application/tar','','','public.data,public.archive');
INSERT INTO types VALUES ('com.apple.keynote.kth','kth','','','','com.apple.package,public.composite-content');
INSERT INTO types VALUES ('com.apple.nspboard-type','','','','','public.text');
INSERT INTO types VALUES ('com.apple.pef-binary','','','','','public.data,public.executable');
INSERT INTO types VALUES ('com.apple.deprecated-application-file','','','','','com.apple.application-file');
INSERT INTO types VALUES ('com.microsoft.windows-dynamic-link-library','dll','','','','');
INSERT INTO types VALUES ('public.assembly-source','s','','','','public.source-code');
INSERT INTO types VALUES ('public.presentation','','','','','public.composite-content');
INSERT INTO types VALUES ('com.apple.framework','framework','','','','com.apple.bundle');
INSERT INTO types VALUES ('public.c-source','c','text/x-c,text/x-csrc','','','public.source-code');
INSERT INTO types VALUES ('public.script','','','','','public.source-code');
INSERT INTO types VALUES ('com.microsoft.advanced-stream-redirector','asx','video/x-ms-asx,application/x-ms-asx,audio/ms-asx','','','public.xml,public.audiovisual-content');
INSERT INTO types VALUES ('public.tiff','tif,tiff','image/tiff','','','public.image');
INSERT INTO types VALUES ('public.xml','xml','text/xml','','','public.text');
INSERT INTO types VALUES ('com.apple.dashboard-widget','wdgt','','','','com.apple.package,com.apple.bundle');
INSERT INTO types VALUES ('public.audio','','','','','public.audiovisual-content');
INSERT INTO types VALUES ('public.python-script','py,py3','text/x-python-script','','','public.shell-script');
INSERT INTO types VALUES ('com.netscape.javascript-source','js,jscript,javascript','text/javascript,application/javascript,application/x-javascript','','','public.source-code,public.executable');
INSERT INTO types VALUES ('public.ruby-script','rb,rbw','text/x-ruby-script,application/x-ruby','','','public.shell-script');
INSERT INTO types VALUES ('public.rtf','rtf','text/rtf','','','public.text');
INSERT INTO types VALUES ('com.apple.application','','','','','public.executable');
INSERT INTO types VALUES ('public.directory','','','','','public.item');
INSERT INTO types VALUES ('public.font','','','','','public.data');
INSERT INTO types VALUES ('public.jpeg-2000','jp2','image/jp2,image/jpeg2000,image/jpeg2000-image','','','public.image');
INSERT INTO types VALUES ('com.apple.symbol-export','exp','','','','public.source-code');
INSERT INTO types VALUES ('com.apple.ink.inktext','','','','','public.data');
INSERT INTO types VALUES ('public.plain-text','','','','','public.text');
INSERT INTO types VALUES ('com.sun.java-archive','jar','application/java-archive,application/x-java-archive,application/x-jar','','','public.data,public.executable,public.archive');
INSERT INTO types VALUES ('com.apple.mach-o-binary','','','','','public.data,public.executable');
INSERT INTO types VALUES ('com.apple.application-file','','','','','com.apple.application,public.data');
INSERT INTO types VALUES ('com.js.efx-fax','efx','image/efax','','','public.fax');
INSERT INTO types VALUES ('com.microsoft.ico','ico','image/vnd.microsoft.icon,image/icon,image/ico','','','public.image');
INSERT INTO types VALUES ('public.object-code','o','application/x-object','','','public.data,public.executable');
INSERT INTO types VALUES ('com.microsoft.windows-media-wm','wm','video/x-ms-wm','','','public.movie,com.microsoft.advanced-systems-format');
INSERT INTO types VALUES ('public.bzip2-archive','bz2','application/bzip2,application/x-bzip','','','public.data,public.archive');
INSERT INTO types VALUES ('public.tar-bzip2-archive','tbz2','application/tar-bzip2,application/x-bzip','','','public.bzip2-archive');
INSERT INTO types VALUES ('public.svg-image','svg','image/svg+xml','','','public.image');
INSERT INTO types VALUES ('public.xbitmap-image','xbm','image/x-bitmap','','','public.image');
INSERT INTO types VALUES ('public.xhtml','xhtml','application/xhtml+xml','','','public.xml');
INSERT INTO types VALUES ('public.sql','sql','application/sql','','','public.text');
INSERT INTO types VALUES ('vnd.sqlite3','sqlite3,sqlite,db','application/vnd.sqlite3','','','public.database,public.data');
INSERT INTO types VALUES ('net.daringfireball.markdown','md,markdown','text/markdown','','','public.plain-text');
